#!/bin/bash

MAKELIST_CXX=(vel_sim RMRC RH_HandWrapper)
MAKELIST_PY=(RHdisp slider)

cd tools
cd geo
make clean
make
make install
cd ../

cd nr
make clean
make
make install
cd ../../

for ((i=0;i<${#MAKELIST_CXX[*]};i++))
{
  cd ${MAKELIST_CXX[i]}
  make clean
  make
  make install
  cd ../
}

for ((i=0;i<${#MAKELIST_PY[*]};i++))
{
  cd ${MAKELIST_PY[i]}
  python bin_update.py
  cd ../
}

cd ../../bin/comp
omniidl -bpython ../../idl/*.idl
