#/usr/bin/env python
# -*- coding: utf-8 -*-
# -*- Python -*-
# Version : 1.0.0
# Vendor : RTC-Center
# date : 09/08/27 (ver1.0.0)
# abstract : script for demonstration
#
import sys
import os
import time

from math import *

from set_env import *

save_path = sys.path[:]
sys.path.append(Rh2LibDir)
#sys.path.append(RtmToolsDir+"/rtc_handle")
from rtc_handle import *

env = RtmEnv(sys.argv,[Rh2VoiceNS,Rh2ArmNS,Rh2CamNS])

for ns in env.name_space :
  env.name_space[ns].list_obj()

sys.path.append(Rh2VoiceToolsDir)
import Rh2Voice_ctrl
from message import *
sys.path.append(Rh2ArmToolsDir)
import Rh2Arm_ctrl
sys.path.append(Rh2CamToolsDir)
import Rh2Cam_ctrl

Rh2Voice_ctrl.assign_variables(env)
Rh2Arm_ctrl.assign_variables(env)
Rh2Arm_ctrl.make_connectors(env)
Rh2Cam_ctrl.assign_variables(env)

#
# import stub files
#
sys.path.append(Rh2IdlDir)
import _GlobalIDL
sys.path = save_path

Rh2Cam_ctrl.activate_components()

# アームが動きます～
Rh2Voice_ctrl.talk(mstr010)
Rh2Arm_ctrl.ready(env,1)
time.sleep(3)
Rh2Arm_ctrl.demo(Rh2Arm_ctrl.RMRC,[Rh2Arm_ctrl.pc,Rh2Arm_ctrl.pd,Rh2Arm_ctrl.pe,Rh2Arm_ctrl.cam])
Rh2Arm_ctrl.gripper_open()
time.sleep(10)
ans = Rh2Cam_ctrl.get_mark()
print ans
cans=['can4','can3','can2','can1']
first=1
time.sleep(3)
for i in range(4) :
  if(ans[i+1]==0):
    if(cans[i]!='can4'):
      if(first==1):
        Rh2Voice_ctrl.talk(mstr033)
        Rh2Arm_ctrl.trush_clean(cans[i], 1)
        first=0
      else:
        Rh2Arm_ctrl.trush_clean(cans[i])
# 廃棄が終了しました。
Rh2Voice_ctrl.talk(mstr034)
time.sleep(3)
# 走行姿勢に戻ります。
Rh2Voice_ctrl.talk(mstr012)
time.sleep(3)
Rh2Arm_ctrl.mode_joint(env)
time.sleep(3)
Rh2Arm_ctrl.move_joint(Rh2Arm_ctrl.RH2ArmControl, Rh2Arm_ctrl.j_squat)
time.sleep(3)
Rh2Arm_ctrl.arm_release(env)
Rh2Cam_ctrl.deactivate_components()
