#!/bin/sh

current_dir=`pwd`
export RTC_DIR=$current_dir/..

rm ./*.dat
rm ./*.log

openhrp-controller-bridge \
--server-name MotorControlFactory \
--module $RTC_DIR/MotorControl/MotorControl.so \
--out-port WheelAngle:MAIN_WHEEL1,MAIN_WHEEL2:JOINT_VALUE \
--in-port WheelTorque:MAIN_WHEEL1,MAIN_WHEEL2:JOINT_TORQUE \
--out-port position:BODY:ABS_TRANSFORM \
--connection WheelAngle:MotorControl0:InCurrentWheelAngle \
--connection WheelTorque:MotorControl0:Torque \
--connection position:MotorControl0:InSimulatedPosition \
--robot-name RefHw

