#!/usr/bin/env python
# -*- Python -*-


import sys
import time
import os
from math import *

#
# set up user environment
#  RtmToolsDir, MyRtcDir, etc.
#
sys.path.append("..")
from set_env import *

#
# import user tools
#
sys.path.append(".")
save_path = sys.path[:]
sys.path.append(Rh2LibDir)
#sys.path.append(RtmToolsDir+'/rtc_handle')
from rtc_handle import *

sys.path = save_path


#
# import stub files
#
sys.path.append(Rh2IdlDir)
import _GlobalIDL

def assign_variables(env) :
 global temp
 temp = env.name_space[Rh2CamNS].rtc_handles['MatchingComponent0.rtc']
 # narrow services
 temp.services['itemposition_service'].provided['item_position'].narrow_ref(globals())

def activate_components() :
  temp.activate()

def deactivate_components() :
  temp.deactivate()

#mark_cognition
def get_mark():
 ans = temp.services['itemposition_service'].provided['item_position'].ref.get_item_position()
 return ans;

#env = RtmEnv(sys.argv,[Rh2CamNS])
#for ns in env.name_space :
#  env.name_space[ns].list_obj()
#assign_variables(env)
