#! /bin/sh
#

RTC_DIR=/opt/rh/RS002/bin/comp
CONF_DIR=/opt/rh/RS002/etc/conf

exec gnome-terminal \
	--tab-with-profile=default --working-directory=${RTC_DIR} -t GamePad -e "./GamePadComp -f ${CONF_DIR}/GamePad.conf" \
	--tab-with-profile=default --working-directory=${RTC_DIR} -t DispPos -e "./DispPositionComp -f ${CONF_DIR}/DispPosition.conf" \
	--tab-with-profile=default --working-directory=${RTC_DIR} -t Dijkstra -e "./DijkstraComp -f ${CONF_DIR}/Dijkstra.conf" \
	--tab-with-profile=default --working-directory=${RTC_DIR} -t TestInputSTART -e "./TestInputComp -f ${CONF_DIR}/Start.conf" \
	--tab-with-profile=default --working-directory=${RTC_DIR} -t TestInputGOAL -e "./TestInputComp -f ${CONF_DIR}/Goal.conf" \
	--tab-with-profile=default --working-directory=${RTC_DIR} -t HazardMesh -e "./HazardMeshComp -f ${CONF_DIR}/HazardMesh.conf" \
	--tab-with-profile=default --working-directory=${RTC_DIR} -t ManagementOfAreaMap -e "./ManagementOfAreaMapComp -f ${CONF_DIR}/ManagementOfAreaMap.conf" \
	--tab-with-profile=default --working-directory=${RTC_DIR} -t PathCnv -e "./PathCnvComp -f ${CONF_DIR}/PathCnv.conf"
